> For the complete documentation index, see [llms.txt](https://docs.keycloakify.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.keycloakify.dev/keycloakify/v5/adding-text-keys.md).

# Adding i18n messages keys

![](/files/RVwo6MAZMeJQ6OEQ1RM1)

In Keycloakify you can't directly eddit the `messages_xx.properties` files, the way to go it to reproduce [this approach](https://github.com/garronej/keycloakify-demo-app/blob/main/src/kcMessagesExtension.ts) ( don't forget to [evaluate the code](https://github.com/garronej/keycloakify-demo-app/blob/9d92307361d19cdfb06a23f46a7003662fae3b34/src/index.tsx#L14) ).

{% hint style="warning" %}
This approach is a bit hacky as it doesn't provide type safety, it needs to be improved.

In the meantime see [this issue](https://github.com/InseeFrLab/keycloakify/issues/17) for other workarounds.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.keycloakify.dev/keycloakify/v5/adding-text-keys.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
